/*==============================================================*/
/* Table: P_TPR_RECLAMATION                                     */
/*==============================================================*/

if not exists(
   select 1 from sys.systable 
   where table_name='P_TPR_RECLAMATION'
     and table_type in ('BASE', 'GBL TEMP')
) then
create table habdbsync.P_TPR_RECLAMATION (
	ID varchar(38) NOT NULL,
	NAME varchar(256) NOT NULL,
	CREATOR varchar(256) NULL,
	SCHEDULE varchar(256) NULL,
	CREATED datetime NOT NULL,
	constraint PK_P_TPR_RECLAMATION primary key clustered ( ID )
) in DATA;

grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION to HABADM;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION to HABDBSYNC;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION to HABGUI;

end if;


/*==============================================================*/
/* View : TPR_VIEW_RECLAMATION_R                                */
/*==============================================================*/

if not exists(select 1 from sys.systable where table_name='TPR_VIEW_RECLAMATION_R' and table_type='VIEW') then

create view HABDBSYNC.TPR_VIEW_RECLAMATION_R as
select
	P_TPR_RECLAMATION.ID,
	P_TPR_RECLAMATION.NAME,
	P_TPR_RECLAMATION.CREATOR,	P_TPR_RECLAMATION.SCHEDULE,
	P_TPR_RECLAMATION.CREATED
from
   habdbsync.P_TPR_RECLAMATION;

grant INSERT,UPDATE,SELECT,DELETE on HABDBSYNC.TPR_VIEW_RECLAMATION_R to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_R to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_R to HABDBSYNC;

end if;


/*==============================================================*/
/* Table: P_TPR_RECLAMATION_SCOPE                               */
/*==============================================================*/

if not exists(
   select 1 from sys.systable 
   where table_name='P_TPR_RECLAMATION_SCOPE'
     and table_type in ('BASE', 'GBL TEMP')
) then

create table habdbsync.P_TPR_RECLAMATION_SCOPE (
	RECLAMATION_ID varchar(38) NOT NULL,
	OBJ_ID varchar(128) NOT NULL,
	OBJ_TYPE varchar(128) NOT NULL,
	OBJ_NAME varchar(256) NOT NULL,
	constraint PK_P_TPR_RECLAMATION_SCOPE primary key clustered ( RECLAMATION_ID, OBJ_ID ),
	FOREIGN KEY FK_P_TPR_RECLAMATION (RECLAMATION_ID) REFERENCES HABDBSYNC.P_TPR_RECLAMATION ON DELETE CASCADE
) in DATA;

grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_SCOPE to HABADM;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_SCOPE to HABDBSYNC;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_SCOPE to HABGUI;

end if;


/*==============================================================*/
/* View : TPR_VIEW_RECLAMATION_SCOPE_R                              */
/*==============================================================*/

if not exists(select 1 from sys.systable where table_name='TPR_VIEW_RECLAMATION_SCOPE_R' and table_type='VIEW') then

create view HABDBSYNC.TPR_VIEW_RECLAMATION_SCOPE_R as
select
	P_TPR_RECLAMATION_SCOPE.RECLAMATION_ID,
	P_TPR_RECLAMATION_SCOPE.OBJ_ID,
	P_TPR_RECLAMATION_SCOPE.OBJ_TYPE,
	P_TPR_RECLAMATION_SCOPE.OBJ_NAME
from
   habdbsync.P_TPR_RECLAMATION_SCOPE;

grant INSERT,UPDATE,SELECT,DELETE on HABDBSYNC.TPR_VIEW_RECLAMATION_SCOPE_R to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_SCOPE_R to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_SCOPE_R to HABDBSYNC;

end if;


/*==============================================================*/
/* Table: P_TPR_RECLAMATION_RUN                                 */
/*==============================================================*/

if not exists(
   select 1 from sys.systable 
   where table_name='P_TPR_RECLAMATION_RUN'
     and table_type in ('BASE', 'GBL TEMP')
) then

create table habdbsync.P_TPR_RECLAMATION_RUN (
	ID varchar(38) NOT NULL,
	RECLAMATION_ID varchar(38) NOT NULL,
	TIME_STARTED datetime NOT NULL,
	TIME_FINISHED datetime NULL,
	VIEWED bit NOT NULL,
	LUNS int NOT NULL,
	SPACE_RECLAIMED bigint,
	constraint PK_P_TPR_RECLAMATION_RUN primary key clustered ( ID ),
	FOREIGN KEY FK_P_TPR_RECLAMATION (RECLAMATION_ID) REFERENCES HABDBSYNC.P_TPR_RECLAMATION ON DELETE CASCADE
) in DATA;

grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_RUN to HABADM;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_RUN to HABDBSYNC;
grant ALTER,DELETE,INSERT,REFERENCES,SELECT,UPDATE on habdbsync.P_TPR_RECLAMATION_RUN to HABGUI;

end if;


/*==============================================================*/
/* View : TPR_VIEW_RECLAMATION_RUN_R                            */
/*==============================================================*/

if not exists(select 1 from sys.systable where table_name='TPR_VIEW_RECLAMATION_RUN_R' and table_type='VIEW') then

create view HABDBSYNC.TPR_VIEW_RECLAMATION_RUN_R as
select
	P_TPR_RECLAMATION_RUN.ID,
	P_TPR_RECLAMATION_RUN.RECLAMATION_ID,
	P_TPR_RECLAMATION_RUN.TIME_STARTED,
	P_TPR_RECLAMATION_RUN.TIME_FINISHED,
	P_TPR_RECLAMATION_RUN.VIEWED,
	P_TPR_RECLAMATION_RUN.LUNS,
	P_TPR_RECLAMATION_RUN.SPACE_RECLAIMED
from
   habdbsync.P_TPR_RECLAMATION_RUN;

grant INSERT,UPDATE,SELECT,DELETE on HABDBSYNC.TPR_VIEW_RECLAMATION_RUN_R to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_RUN_R to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_RECLAMATION_RUN_R to HABDBSYNC;

end if;


/*=============================================================*/
/* Values                                                      */
/*=============================================================*/
INSERT INTO HABDBSYNC.CATEGORY_VIEW_R ON EXISTING UPDATE VALUES ('TPR');
INSERT INTO HABDBSYNC.UI_VIEW_RESOURCE_R ON EXISTING UPDATE VALUES  ('TPR');
INSERT INTO HABDBSYNC.UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES  ('TPR', 'en_US', 'TPR');
