
/*==============================================================*/
/* View : TPR_VIEW_UI_RECLAMATION                               */
/*==============================================================*/

if not exists(select 1 from sys.systable where table_name='TPR_VIEW_UI_RECLAMATION' and table_type='VIEW') then

create view HABDBSYNC.TPR_VIEW_UI_RECLAMATION as
select
	RECLAMATION.ID,
	RECLAMATION.NAME,
	RECLAMATION.CREATOR,
	RECLAMATION.CREATED,
 SCHED.CRON_TYPE AS SCHEDULE_TYPE, 
 SCHED.RECURRENCE_TYPE AS SCHEDULE,
 SCHED.END_DATE AS END_DATE,
 SCHED.START_DATE AS START_DATE,

 LIST(SCOPE.OBJ_ID order by SCOPE.OBJ_NAME) as SCOPE_ID,
 LIST(SCOPE.OBJ_NAME order by SCOPE.OBJ_NAME) as SCOPE_NAME,
 LIST(SCOPE.OBJ_TYPE order by SCOPE.OBJ_NAME) as SCOPE_TYPE,

(select top 1 run.id
from TPR_VIEW_RECLAMATION_RUN_R run
where run.reclamation_id=RECLAMATION.ID
order by case when run.TIME_FINISHED IS NULL then 0 else 1 end, run.TIME_FINISHED desc ) as LAST_RUN_ID,

(select top 1 run.TIME_FINISHED
from TPR_VIEW_RECLAMATION_RUN_R run
where run.reclamation_id=RECLAMATION.ID
order by case when run.TIME_FINISHED IS NULL then 0 else 1 end, run.TIME_FINISHED desc ) as LAST_RUN_FINISHED,

 STRING('^',RECLAMATION.NAME,'$^',SCOPE_NAME,'$') as SEARCH_KEY

from
   TPR_VIEW_RECLAMATION_R RECLAMATION
LEFT OUTER JOIN TPR_VIEW_RECLAMATION_SCOPE_R AS SCOPE ON SCOPE.RECLAMATION_ID=RECLAMATION.ID
LEFT OUTER JOIN SCHEDULE_VIEW_R SCHED ON SCHED.NAME=RECLAMATION.NAME AND SCHED.CATEGORY_ID='TPR'

GROUP BY RECLAMATION.ID, RECLAMATION.NAME, CREATOR, CREATED, SCHEDULE, SCHEDULE_TYPE, END_DATE, START_DATE;

grant INSERT,UPDATE,SELECT,DELETE on HABDBSYNC.TPR_VIEW_UI_RECLAMATION to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_UI_RECLAMATION to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_UI_RECLAMATION to HABDBSYNC;

end if;



/*==============================================================*/
/* View : TPR_VIEW_UI_RECLAMATION_RUN                           */
/*==============================================================*/

if not exists(select 1 from sys.systable where table_name='TPR_VIEW_UI_RECLAMATION_RUN' and table_type='VIEW') then

create view HABDBSYNC.TPR_VIEW_UI_RECLAMATION_RUN as
SELECT 
 RUN.ID, 
 RUN.RECLAMATION_ID,
 RUN.TIME_STARTED, 
 RUN.TIME_FINISHED,
 RUN.VIEWED, 
 RUN.LUNS,
 RUN.SPACE_RECLAIMED
 
FROM TPR_VIEW_RECLAMATION_RUN_R RUN
LEFT OUTER JOIN SF_VIEW_SOLUTION_R SOL ON RUN.ID=SOL.ID;

grant INSERT,UPDATE,SELECT,DELETE on HABDBSYNC.TPR_VIEW_UI_RECLAMATION_RUN to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_UI_RECLAMATION_RUN to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on HABDBSYNC.TPR_VIEW_UI_RECLAMATION_RUN to HABDBSYNC;

end if;
