#!/opt/VRTSsfmh/bin/perl

BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ( $^O !~ /Win32/i ) }

use VRTS::AddOnInfo;
use VRTS::Config;
use VRTS::Util;
use File::Copy;
require File::Path;
require VRTS::CMD;
require File::Spec;

my $addon_dir     = VRTS::Paths::get_path("DeployStoreDir");
my $install_dir   = VRTS::Paths::get_path("InstallDir");
my $cs_install_dir = $install_dir;
$cs_install_dir	  =~ s/VRTSsfmh/VRTSsfmcs/;
my $log_dir       = VRTS::Paths::get_path("AppDir");
my $addon_dir     = VRTS::Paths::get_path("DeployStoreDir");
my $log_dir_cs    = $log_dir;
$log_dir_cs       =~ s/VRTSsfmh/VRTSsfmcs/g;
my $appdircs      = $install_dir;
$appdircs         =~ s/VRTSsfmh/VRTSsfmcs/g;
my $db_isql       = File::Spec->catfile($cs_install_dir,"config","adm","db_isql.sh");
$db_isql	  = File::Spec->catfile($cs_install_dir,"config","adm","db_isql.bat") if ( $^O =~ /Win32/i);

my $xdbadm        = File::Spec->catfile($install_dir,"bin","xdbadm");
$addon_dir        = File::Spec->catfile($addon_dir,"VRTSsfmtpr-3.1.201.0");
my $esmweb        = File::Spec->catfile($appdircs,"esmweb","precache","web");
my $extn_tpr      = File::Spec->catfile($appdircs,"esmweb","webgui","sm","WEB-INF","lib");
my $jsp_tpr       = File::Spec->catfile($appdircs,"esmweb","webgui","sm","plugins","tpr","jsp");
my $XML           = File::Spec->catfile($addon_dir,"cms","TPRCache.xml");
my $JAR1          = File::Spec->catfile($addon_dir,"cms","TPRExtension.jar");
my $JSP1	  = File::Spec->catfile($addon_dir,"cms","TPRScheduleDetails.jsp");
my $JSP2	  = File::Spec->catfile($addon_dir,"cms","SummaryPanelRenderer.jsp");
my ($installdircs,$a, $b,$c) = VRTS::Util::get_common_paths();
my $help_dir      = File::Spec->catfile($addon_dir,"EN_US","VOMTPRADDONCURRENT");
my $to_dir        = File::Spec->catfile($appdircs,"esmweb","webgui","symhelp","Content","EN_US","VOMTPRADDONCURRENT");

    my $cms_version = &VRTS::Config::MANIFEST_VERSION;
    chomp $cms_version;
    my @build_numbers = split(/\./, $cms_version);
    $cms_build = $build_numbers[2];
    my $supported_build = "400"; #Supports CMS build 400 and above (3.1)

    if ($cms_build < $supported_build) {
        print STDERR "TPR requires VOM 3.1 or higher.\n";
        print STDERR "Current Version:$cms_version\n";
        exit(1);
    }

# DB related changes should only happen on Active node in CMS-HA
# not on slave node
if ( VRTS::AddOnInfo::is_CS() )
{
    $cmd = make_command($xdbadm,
           "-g",
           "-u",
           "HABDBSYNC",
           "-o",
           File::Spec->catfile($odbc_ini_dir,".odbc.ini"),
           "--database",
           "SFMdb",
           "-c",
           File::Spec->catfile($log_dir_cs,"conf"));

    open (HAN, $cmd. "|");
    my $pass = <HAN>;
    close(HAN);

    chomp $pass;
    $ENV{"SFMDBPASSWD"} = $pass;

    # Need to init all the sql files under the SQL dir..
    #Create DB tables and the helper views and sp's for the UI to function..

    my $file = undef;
    my $dir = File::Spec->catfile($addon_dir ,"cms");
    opendir(DIR, "$dir");
    my @sql_file_list;
    while(defined($file = readdir(DIR)))
    {
        next if $file =~ /^\.\.?$/;
        next if $file !~ /\.sql$/;

        push(@sql_file_list, $file);
    }
    close(DIR);

    # Now sort the list obtained...
    @sql_file_list = sort @sql_file_list;

    foreach my $single_list (@sql_file_list)
    {
        
        my $cmd = make_command($db_isql, "HABDBSYNC",
           File::Spec->catfile($addon_dir,"cms","$single_list"));


        $out = system($cmd);
        $out = $out << 8;
        if ($out != 0)
        {
            print STDERR "TPR Schema Creation Failed under [$single_list]\n";
            exit(1);
        }
    }
}

   #Copy help files
   VRTS::Util::copy_recursively($help_dir,$to_dir);

   #Create the log dir only if it does not exist
   if (! -d $extn_tpr)
   {
      eval ( File::Path::mkpath("$extn_tpr", 0, 0755) );
   }

   #copy the jars after creating the location
   print STDERR "Copying file $JAR1 to $extn_tpr \n";
   copy($JAR1,$extn_tpr) or print STDERR "Copy failed: $! \n";

   #Create the log dir only if it does not exist
   if (! -d $jsp_tpr)
   {
      eval ( File::Path::mkpath("$jsp_tpr", 0, 0755) );
   }

   #copy jsps after creating the location
   print STDERR "Copying file $JSP1 to $jsp_tpr \n";
   print STDERR "Copying file $JSP2 to $jsp_tpr \n";
   copy($JSP1,$jsp_tpr) or print STDERR "Copy failed: $! \n";
   copy($JSP2,$jsp_tpr) or print STDERR "Copy failed: $! \n";

   #Copy the xml file - done last, so if failure, nothing to load
   print STDERR "Copying file $XML to $esmweb \n";
   copy($XML,$esmweb);

   print STDERR "TPR Add-on Setup was successful\n";

#########
# Helper routines
#########

sub make_command 
{
    my @arr = @_;
    for (@arr) 
    {
        $_ = qq["$_"] if /\s/;
    } 

    my $_command_to_execute = join(' ',@arr);
    return ($_command_to_execute);
}
